/*
 * Projet LO43
 * Julien Miltat -- Julien Rosener -- Thomas Petazzoni
 * Semestre automne 2002-2003
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Interface extends JFrame implements ActionListener
{
    final JMenuItem menunouveau;
    final JMenuItem menuquitter;
    final JMenuItem menufermer;
    final JMenuItem menusimustart;
    final JMenuItem menusimustop;
    JLabel    bienvenue   = null;
    MainPanel mainPanel   = null;
    EnvironnementPanel ep = null;

    Interface()
    {
	JMenuBar  menubar        = new JMenuBar();
	JMenu     menufichier    = new JMenu("Fichier");
	JMenu     menusimulation = new JMenu("Simulation");

	bienvenue      = new JLabel("Pour creer un monde : Fichier/Nouveau");

	menunouveau    = new JMenuItem("Nouveau");
	menufermer     = new JMenuItem("Fermer");
	menuquitter    = new JMenuItem("Quitter");
	menusimustart  = new JMenuItem("Start");
	menusimustop   = new JMenuItem("Stop");

	setJMenuBar(menubar);
	menubar.add(menufichier);
	menubar.add(menusimulation);

	menunouveau.setEnabled(true);
	menunouveau.addActionListener(this);
	menufichier.add(menunouveau);
	menufermer.setEnabled(false);
	menufermer.addActionListener(this);
	menufichier.add(menufermer);
	menufichier.addSeparator();
	menuquitter.addActionListener(this);
	menufichier.add(menuquitter);

	menusimustart.setEnabled(false);
	menusimustart.addActionListener(this);
	menusimustop.setEnabled(false);
	menusimustop.addActionListener(this);
	menusimulation.add(menusimustart);
	menusimulation.add(menusimustop);

	getContentPane().add(bienvenue, BorderLayout.NORTH);

	setSize(300, 300);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	setTitle("Projet LO43");
	setResizable(false);
	setVisible(true);
    }

    public void actionPerformed(ActionEvent e)
    {
	JMenuItem source = (JMenuItem) (e.getSource());
	
	if(source == menunouveau)
	    {
		NouveauMondeDialog diag;
		
		diag = new NouveauMondeDialog(this);
		diag.pack();
		diag.setVisible(true);
		menunouveau.setEnabled(false);
		menufermer.setEnabled(true);
		menusimustart.setEnabled(false);
		menusimustop.setEnabled(true);
	    }
	else if(source == menufermer)
	    {
		ep.stop();
		remove(mainPanel);
		getContentPane().add(bienvenue, BorderLayout.NORTH);
		setSize(300, 300);
		repaint();
		menunouveau.setEnabled(true);
		menufermer.setEnabled(false);
		menusimustart.setEnabled(true);
		menusimustop.setEnabled(false);
	    }
	else if(source == menuquitter)
	    {
		System.exit(0);
	    }
	else if(source == menusimustart)
	    {
		ep.simuStart();
		menusimustart.setEnabled(false);
		menusimustop.setEnabled(true);
	    }
	else if(source == menusimustop)
	    {
		ep.simuStop();
		menusimustart.setEnabled(true);
		menusimustop.setEnabled(false);
	    }
    }

    public void changeText(String text)
    {
	mainPanel.changeText(text);
    }

    public void createWorld(int x, int y, int nbfourm,
			    int foodmax, int foodmin, int foodtotal, 
			    int obsttotal, double evapphero, 
			    double zerophero)
    {
	if(bienvenue != null)
	    {
		System.out.println("Creation d'un super monde " + zerophero);
		remove(bienvenue);
		ep  = new EnvironnementPanel(x, y, nbfourm, foodmax, 
					     foodmin, foodtotal, 
					     obsttotal, evapphero, 
					     zerophero, this);
		mainPanel = new MainPanel(ep, x, y);
		getContentPane().add(mainPanel);
	    }
	else if(mainPanel != null)
	    {
		remove(mainPanel);
		mainPanel = null;
		ep  = new EnvironnementPanel(x, y, nbfourm, foodmax, foodmin, 
					     foodtotal, obsttotal, 
					     evapphero, zerophero, this);
		mainPanel = new MainPanel(ep, x, y);
		getContentPane().add(mainPanel);
	    }

	menusimustart.setEnabled(false);
	menusimustop.setEnabled(true);
	setSize(x*2+200, y*2+70);
	setVisible(true);
	repaint();
    }

    public static void main(String[] args)
    {
	Interface i = new Interface();
    }
}










