import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.beans.*; //Property change stuff

class NouveauMondeDialog extends JDialog implements PropertyChangeListener
{
    private JOptionPane optionPane;
    final String btnOk       = "OK";
    final String btnAnnuler  = "Annuler";
    JTextField sizeX         = new JTextField("200",  5);
    JTextField sizeY         = new JTextField("200",  5);
    JTextField nbFourmiliere = new JTextField("4"  ,  5);
    JTextField foodMax       = new JTextField("1000", 5);
    JTextField foodMin       = new JTextField("500",  5);
    JTextField foodTotal     = new JTextField("100",  5);
    JTextField obstTotal     = new JTextField("1000", 5);
    JTextField evapPhero     = new JTextField("0.98", 5);
    JTextField zeroPhero     = new JTextField("0.1",  5);

    final Interface frame;
    
    public NouveauMondeDialog(Interface f)
    {
	super(f, true);
	frame = f;

	final String     text          = "Creation d'un nouveau monde";
	final JLabel     labelSixeX    = new JLabel("Taille (X)");
	final JLabel     labelSixeY    = new JLabel("Taille (Y)");
	final JLabel     labNbFourm    = new JLabel("Nombre de fourmilieres");
	final JLabel     labFoodMax    = new JLabel("Max de nourriture par case");
	final JLabel     labFoodMin    = new JLabel("Min de nourriture par case");
	final JLabel     labFoodTotal  = new JLabel("Nombre de points de nourriture");
	final JLabel     labObstTotal  = new JLabel("Nombre d'obstacles");
	final JLabel     labEvapPhero  = new JLabel("Taux d'evaporation des pheronomones");
	final JLabel     labZeroPhero  = new JLabel("Taux zero de pheromone");

	final JPanel     panel         = new JPanel();
	
	panel.setLayout(new GridLayout(9, 2, 1, 1));
	panel.add(labelSixeX);
	panel.add(sizeX);
	panel.add(labelSixeY);
	panel.add(sizeY);
	panel.add(labNbFourm);
	panel.add(nbFourmiliere);
	panel.add(labFoodMax);
	panel.add(foodMax);
	panel.add(labFoodMin);
	panel.add(foodMin);
	panel.add(labFoodTotal);
	panel.add(foodTotal);
	panel.add(labObstTotal);
	panel.add(obstTotal);
	panel.add(labEvapPhero);
	panel.add(evapPhero);
	panel.add(labZeroPhero);
       	panel.add(zeroPhero);
	
	Object[] array   = { text, panel };
	
	Object[] options = { btnOk, btnAnnuler };

	optionPane = new JOptionPane(array,
				     JOptionPane.QUESTION_MESSAGE,
				     JOptionPane.YES_NO_OPTION,
				     null,
				     options,
				     options[0]);
	setContentPane(optionPane);
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

	setTitle("Nouveau monde");

	optionPane.addPropertyChangeListener(this);
    }


    public void propertyChange(PropertyChangeEvent e) {
	String prop = e.getPropertyName();
	
	if(isVisible()
	   && (e.getSource() == optionPane)
	   && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
	       prop.equals(JOptionPane.INPUT_VALUE_PROPERTY)))
	    {
		Object value = optionPane.getValue();
		
		if (value == JOptionPane.UNINITIALIZED_VALUE) 
		    return;
		
		optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
		
		/* Bouton OK */
		if(value.equals(btnOk))
		    {
			setVisible(false);
			
			frame.createWorld(Integer.valueOf(sizeX.getText()).intValue(),
					  Integer.valueOf(sizeY.getText()).intValue(),
					  Integer.valueOf(nbFourmiliere.getText()).intValue(),
					  Integer.valueOf(foodMax.getText()).intValue(),
					  Integer.valueOf(foodMin.getText()).intValue(),
					  Integer.valueOf(foodTotal.getText()).intValue(),
					  Integer.valueOf(obstTotal.getText()).intValue(),
					  Float.valueOf(evapPhero.getText()).floatValue(),
					  Float.valueOf(zeroPhero.getText()).floatValue());

		    }
		/* Bouton Annuler ou fermeture de la boite
		 * de dialogue */
		else
		    {
			setVisible(false);
		    }
	    }
    }
}
