/*
 * Projet LO43
 * Julien Miltat -- Julien Rosener -- Thomas Petazzoni
 * Semestre automne 2002-2003
 */

/**
   Cette classe est chargee de realiser toutes les interactions entre
   Java et C++.
*/

class Simulation
{
    private EnvironnementPanel ep;

    synchronized public static native void initIDs();
    synchronized public native void newenvironnement(int sixex, int sizey, 
						     int foodmax, int foodmin, 
						     int foodtotal, 
						     int obsttotal, 
						     float evapphero, 
						     float zerophero);
    synchronized public native int  addFourmiliere();
    synchronized public native void delenvironnement();
    synchronized public native void simu();
    synchronized public native int  getgrille(int x, int y);
    synchronized public native int  getFourmilierePosX(int i);
    synchronized public native int  getFourmilierePosY(int i);
    synchronized public native int  getNbFourmiliere();
    synchronized public native int  getFourmiliereFourmiPosY(int fourmiliere, 
						int fourmi);
    synchronized public native int  getFourmiliereFourmiPosX(int fourmiliere,
						int fourmi);
    synchronized public native int  getFourmiliereNbrFourmis(int i);
    synchronized public native int  getFourmiliereFood(int i);
    synchronized public native int  getFourmilierePhero(int fourmiliere, 
							int x, int y);


    static
    {
	try
	    {
		System.loadLibrary("simu");
		initIDs();
	    }
	catch (java.lang.UnsatisfiedLinkError e)
	    {
		System.out.println(e);
		System.exit(1);
	    }
    }

    Simulation(int sizex, int sizey, int foodmax, int foodmin, 
	       int foodtotal, int obsttotal, double evapphero, 
	       double zerophero, EnvironnementPanel envpan)
    {
	System.out.println("Constructeur --> " + zerophero);
	ep = envpan;
	newenvironnement(sizex, sizey, foodmax, foodmin, foodtotal, obsttotal, 
			 (float) evapphero, (float) zerophero);
	System.out.println("Fin du constructeur");
    }

    public void destroy()
    {
	delenvironnement();
    }

    /* Ces fonctions sont juste des wrappers pour l'EnvironnementPanel
     * associe */
    private void paintFourmi(int x, int y, int nf)   
    { ep.paintFourmi(x, y, nf);   }

    private void clearFourmi(int x, int y, int nf)  
    { ep.clearFourmi(x, y, nf);  }

    private void paintObst(int x, int y) 
    { ep.paintObst(x,y); }

    private void paintFood(int x, int y)     
    { ep.paintFood(x,y);     }
    
    private void clearFood(int x, int y)    
    { ep.clearFood(x,y);    }
    
    private void paintPhero(int x, int y, int nf) 
    { ep.paintPhero(x, y, nf); }

    private void clearPhero(int x, int y, int nf) 
    { ep.clearPhero(x, y, nf); }

    private void paintFourmiliere(int x, int y, int nf) 
    { ep.paintFourmiliere(x, y, nf); }
    
    private void clearFourmiliere(int x, int y, int nf) 
    { ep.clearFourmiliere(x, y, nf); }
}
