/*
 * Projet LO43
 * Julien Miltat -- Julien Rosener -- Thomas Petazzoni
 * Semestre automne 2002-2003
 */

#include <iostream.h>
#include "Simulation.h"
#include "environnement.h"
#include "fourmi.h"
#include "fourmiliere.h"
#include "graphics.h"
#include "common.h"

static environnement *e  = NULL; /* Environnement des fourmis (C++) courant */
static mygraphics *jg = NULL; /* Classe pour l'affichage Java */

environnement *getenvironnement()
{
  return e;
}

void Java_Simulation_newenvironnement  (JNIEnv *env, jobject o, jint sizex, 
					jint sizey, jint foodmax, jint foodmin, 
					jint foodtotal, jint obsttotal, 
					jfloat evapphero, jfloat zerophero)
{
  ASSERT_FATAL(jg != NULL && e == NULL);
  
  if(e == NULL)
    {
      jg->objregister(o);
      e      = new environnement(sizex, sizey, foodmax, foodmin, 
				 foodtotal, obsttotal, evapphero, 
				 zerophero, *jg);
    }
}

void  Java_Simulation_delenvironnement (JNIEnv *env, jobject o)
{
  ASSERT_FATAL(e != NULL);

  if(e != NULL)
    {
      jg->objunregister();
      delete(e);
      e = NULL;
    }
}

void Java_Simulation_simu (JNIEnv *env, jobject o)
{
  if(e != NULL)
    e->simu();
}

jint Java_Simulation_getgrille (JNIEnv *env, jobject o, jint i, jint j)
{
  if(e != NULL)
    return e->getGrille(i,j);

  return 0;
}

jint Java_Simulation_getFourmilierePosX (JNIEnv *env, jobject o, jint i)
{
  return e->getFourmiliere(i)->getX();
}

jint Java_Simulation_getFourmilierePosY (JNIEnv *env, jobject o, jint i)
{
  return e->getFourmiliere(i)->getY();
}

jint Java_Simulation_getFourmiliereNbrFourmis (JNIEnv *env, jobject o, jint i)
{
  return e->getFourmiliere(i)->getNbrFourmis();
}

jint Java_Simulation_getFourmiliereFourmiPosX (JNIEnv *env, jobject o, 
					       jint fourmiliere,
					       jint fourmi)
{
  return e->getFourmiliere(fourmiliere)->get(fourmi)->getX();
}

jint Java_Simulation_getFourmiliereFourmiPosY (JNIEnv *env, jobject o, 
					       jint fourmiliere,
					       jint fourmi)
{
  return e->getFourmiliere(fourmiliere)->get(fourmi)->getY();
}

jint Java_Simulation_getFourmiliereFood(JNIEnv *env, jobject o, 
					jint fourmiliere)
{
  return e->getFourmiliere(fourmiliere)->getFood();
}

jint Java_Simulation_getNbFourmiliere(JNIEnv *env, jobject o)
{
  return e->nbFourmiliere();
}

jint Java_Simulation_getFourmilierePhero(JNIEnv *env, jobject o, 
					 jint fourmiliere, jint x, jint y)
{
  return e->getFourmiliere(fourmiliere)->hasPhero(x, y);
}

jint Java_Simulation_addFourmiliere(JNIEnv *env, jobject o)
{
  return e->addFourmiliere(); 
}

void Java_Simulation_initIDs(JNIEnv *env, jclass cls)
{
  jg = new  mygraphics(env, cls);
}
