/*
 * Projet LO43
 * Julien Miltat -- Julien Rosener -- Thomas Petazzoni
 * Semestre automne 2002-2003
 */
#ifndef __MYGRAPHICS_H__
#define __MYGRAPHICS_H__

#include <jni.h>
#include <iostream.h>

/*
 *  Classe de Glue pour l'affichage dans une interface graphique en
 *  Java 
 */

class mygraphics
{
 private:
  /* Les identifiants de methodes */
  jmethodID paintFourmiMID;
  jmethodID clearFourmiMID;
  jmethodID paintObstMID;
  jmethodID paintFoodMID;
  jmethodID clearFoodMID;
  jmethodID paintPheroMID;
  jmethodID clearPheroMID;
  jmethodID paintFourmiliereMID;
  jmethodID clearFourmiliereMID;
  /* L'environnement JNI */
  JNIEnv   *env;
  /* L'objet Simulation courant */
  jobject   obj;
 public:
  mygraphics(JNIEnv *env0, jclass cls)
    {
      env                 = env0;
      /* Initialisation des identifiants de methodes */
      paintFourmiMID      = env->GetMethodID(cls, "paintFourmi", "(III)V");
      clearFourmiMID      = env->GetMethodID(cls, "clearFourmi", "(III)V");
      paintObstMID        = env->GetMethodID(cls, "paintObst"  , "(II)V");
      paintFoodMID        = env->GetMethodID(cls, "paintFood"  , "(II)V");
      clearFoodMID        = env->GetMethodID(cls, "clearFood"  , "(II)V");
      paintPheroMID       = env->GetMethodID(cls, "paintPhero" , "(III)V");
      clearPheroMID       = env->GetMethodID(cls, "clearPhero" , "(III)V");
      paintFourmiliereMID = env->GetMethodID(cls, "paintFourmiliere", "(III)V");
      clearFourmiliereMID = env->GetMethodID(cls, "clearFourmiliere", "(III)V");
    }
  
  /* Enregistrement de l'objet Simulation courant */
  void objregister(jobject o) 
    {
      /* Ceci cree une nouvelle reference globale vers l'objet o */
      obj = env->NewGlobalRef(o);
    }
  
  /* Destruction de la reference globale vers l'objet Simulation */
  void objunregister()
    {
      env->DeleteGlobalRef(obj);
    }

  /*
   * Wrappers pour toutes les methodes d'affichage
   */

  void paintFourmi(int x, int y, int nf) 
    { 
      env->CallVoidMethod(obj, paintFourmiMID, x, y, nf);
    }
  
  void clearFourmi(int x, int y, int nf)
    { 
      env->CallVoidMethod(obj, clearFourmiMID, x, y, nf);
    }
  
  void paintObst(int x, int y)  
    { 
      env->CallVoidMethod(obj, paintObstMID, x, y);
    }
  
  void paintFood(int x, int y)
    { 
      env->CallVoidMethod(obj, paintFoodMID, x, y);
    }
  
  void clearFood(int x, int y)
    { 
      env->CallVoidMethod(obj, clearFourmiMID, x, y);
    }
  
  void paintPhero(int x, int y, int nf)
    { 
      env->CallVoidMethod(obj, paintPheroMID, x, y, nf);
    }
  
  void clearPhero(int x, int y, int nf)
    { 
      env->CallVoidMethod(obj, clearPheroMID, x, y, nf);
    }
  
  void paintFourmiliere(int x, int y, int nf)
    {
      env->CallVoidMethod(obj, paintFourmiliereMID, x, y, nf);
    }

  void clearFourmiliere(int x, int y, int nf)
    {
      env->CallVoidMethod(obj, clearFourmiliereMID, x, y, nf);
    }
};

#endif
