/*
 * Projet LO43
 * Julien Miltat -- Julien Rosener -- Thomas Petazzoni
 * Semestre automne 2002-2003
 */

#include <iostream.h>
#include <stdio.h>
#include "fourmi.h"

/*
 * FourmiElt
 */
FourmiElt::FourmiElt(fourmi &fourmi)
{
  f = &fourmi;
  suivant = NULL;
  precedent = NULL;
}

/*
 * ListeFourmis
 */
ListeFourmis::ListeFourmis()
{
  current    = NULL;
  tete       = NULL;
  nb_fourmis = 0;
}

int ListeFourmis::existe(fourmi& f)
{
  FourmiElt *p;

  for (p = tete; p != NULL; p = p->suivant)
    if(p->f->numeroFourmi() == f.numeroFourmi())
      return true;

  return false;
}

FourmiElt* ListeFourmis::cherche(fourmi &f)
{
  FourmiElt *p;

  for (p = tete; p != NULL; p = p->suivant)
    if(p->f->numeroFourmi() == f.numeroFourmi())
      return p;

  return NULL;
}

void ListeFourmis::ajouter(fourmi& f)
{
  if(existe(f))
    return;

  FourmiElt *elt = new FourmiElt(f);

  if(tete)
    {
      tete->precedent = elt;
      elt->suivant    = tete;
      tete            = elt;
    }
  else
    {
      tete = elt;
    }

  nb_fourmis++;
}

void ListeFourmis::supprimer(fourmi& f)
{
  FourmiElt *fe = cherche(f);

  if(!fe)
    return;

  if(fe->precedent)
    {
      fe->precedent->suivant = fe->suivant;
    }
  else
    {
      tete = fe->suivant;
    }

  if(fe->suivant)
    {
      fe->suivant->precedent = fe->precedent;
    }

  nb_fourmis--;
  delete(fe);
} 

void ListeFourmis::affiche()
{
  FourmiElt *fe;

  cout << "Il y a " << nb_fourmis << " fourmis dans la liste" << endl;
  for (fe = tete; fe != NULL; fe = fe->suivant)
    {
      cout << *(fe->f);
    }
}

ListeFourmis& ListeFourmis::operator+=(fourmi& f)
{
  ajouter(f);
  return *this;
}

ListeFourmis& ListeFourmis::operator-=(fourmi& f)
{
  supprimer(f);
  return *this;
}

fourmi *ListeFourmis::get(int i)
{
  FourmiElt *fe;
  int idx;

  for (fe = tete, idx = 0; fe != NULL; fe = fe->suivant, idx++)
    {
      if(idx == i)
	return fe->f;
    }  

  return NULL;
}

fourmi *ListeFourmis::getFirst()
{
  if(current != NULL)
    {
      fprintf(stderr, "Fatal error : current=0x%x\n", (unsigned) current);
      exit(1);
    }
  
  current = tete;
  return tete->f;
}

fourmi *ListeFourmis::getNext()
{
  // Est-on deja a la fin de la liste ?
  if(current == NULL)
    return NULL;

  // Non -> on passe a l'elt suivant
  current = current->suivant;

  // A-t-on maintenant atteint la fin de la liste ?
  if (current == NULL)
    return NULL;

  return current->f;
}

ostream& operator<< (ostream& o, ListeFourmis& lf)
{
  lf.affiche();
  return o;
}
